#! /bin/sh
#========================================================================
# ymd2yd converts yyyymmdd to yyyyddd
# usage ymd2yd 19980429
#
# Author: Mo Budlong <mo.budlong@sunworld.com>
#
# Source: SunWorld Online UNIX 101 columns:
#	http://www.sunworld.com/sunworldonline/swol-11-1998/swol-11-unix101.html
#	http://www.sunworld.com/swol-12-1998/swol-12-unix101.html?1201a
#
# [11-Dec-1998]
#========================================================================
# Source:
# if there is no command line argument, assume the date
# is coming in on a pipe and use read to collect it

if [ X$1 = X ]
then
        read  dt
else
        dt=$1
fi

# break the yyyymmdd into separate parts for year, month, and day

y=`expr $dt / 10000`
m=`expr \( $dt % 10000 \) / 100`
d=`expr $dt % 100`

# add the days in each month, up to but not including the month itself,
# into the days. For example, if the date is 19980203, extract the
# number of days in January and add it to 03. If the date is June 14, 1998,
# extract the number of days in January, February, March, April, and May
# and add them to 14.

x=1
while [ `expr $x \< $m` = 1 ]
do
        md=`monthdays $y $x`
        d=`expr $d + $md`
        x=`expr $x \+ 1`
done

# combine the year and day back together again and you have the julian date.

jul=`expr \( $y \* 1000 \) + $d`
echo $jul
